/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/

#include "gdamsynthnoise.h"

#include <stdlib.h>

static int gdam_synth_noise_synthesize(GdamSynthSource* source,
                                        gdouble*         out,
					int              len)
{
	int rv = len;
	while (len-- > 0) {
		*out = (gdouble) (rand() - RAND_MAX/2) / RAND_MAX;
		out++;
	}
	return rv;
}

static void gdam_synth_noise_init(GdamSynthNoise* synth_noise)
{
}
static void gdam_synth_noise_class_init(GdamSynthSourceClass* klass)
{
	klass->synthesize = gdam_synth_noise_synthesize;
}

GtkType gdam_synth_noise_get_type()
{
	static GtkType synth_noise_type = 0;
	if (!synth_noise_type) {
		static const GtkTypeInfo synth_noise_info = {
			"GdamSynthNoise",
			sizeof(GdamSynthNoise),
			sizeof(GdamSynthNoiseClass),
			(GtkClassInitFunc) gdam_synth_noise_class_init,
			(GtkObjectInitFunc) gdam_synth_noise_init,
			/* reserved_1*/ NULL,
			/* reserved_2*/ NULL,
			(GtkClassInitFunc) NULL
		};
		GtkType parent = GDAM_TYPE_SYNTH_SOURCE;
		synth_noise_type = gtk_type_unique(parent,
		                                 &synth_noise_info);
	}
	return synth_noise_type;
}
